<?php
namespace Teknisa\CMP\Modules\NecessidadeCompras\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp03800PreviaDoCalculoDaNecessidadeDeComprasRelat extends \Zeedhi\Framework\Controller\Report {
    protected $entityManager;
    protected $birtStrategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;
    protected $qr2Strategy;

    public function __construct($reportService, $entityManager, $reportStrategies, $newCode, $environment, $connection, $dataSourceManager, $qr2Strategy) {
        $this->entityManager     = $entityManager;
        $this->reportStrategies  = $reportStrategies;
        $this->reportService     = $reportService;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
        $this->connection        = $connection;
        $this->dataSourceManager = $dataSourceManager;
        $this->qr2Strategy       = $qr2Strategy;
    }
   
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        ini_set('default_socket_timeout', 10000);
        $row = $request->getRow();
        
        if($row['STRATEGY'] == "BIRT") {
            $row["DATAINI1"] = $row["DATAINI"];
            $row["DATAFIN1"] = $row["DATAFIN"];
            
            $this->reportStrategy = $this->getStrategyByName($row['STRATEGY']);
            $this->reportStrategy->setReportFormat($row['QR2TYPE']);
            $this->stNomeRel = $this->getReportName($row);
            $this->reportMapping[$this->stNomeRel] = 
                array(
                        'strategy' => $row['STRATEGY'],
                        'parameterMapping'  => array(
                            "NRORG"         => "P_NRORG",
                            "NRNECECOMP"    => "P_NRNECECOMP",
                            "CDFILIAL"      => "P_CDFILIAL",
                            "DATAINI"       => "P_DATAINI",
                            "DATAFIN"       => "P_DATAFIN",
                            "FILIPROC"      => "P_FILIPROC",
                            "DATAINI1"      => "P_DATAINI1",
                            "DATAFIN1"      => "P_DATAFIN1"
                        ),
                );
        } else if($row['STRATEGY'] == "QR2") {
            $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
            $this->stNomeRel = $this->getReportName($row);
            $this->reportMapping[$this->stNomeRel] =
                array(
                    'strategy' => $row['STRATEGY'],
                    'parameterMapping' =>
                        array(
                            'CDFILIAL'          => 'P_CDFILIAL',
                            'NRNECECOMP'        => 'P_NRNECECOMP',
                            'DATAINI'           => 'P_DATAINI',
                            'DATAFIN'           => 'P_DATAFIN',
                            'FILIPROC'          => 'P_FILIPROC',
                            'MANTERPRODQTZERO'  => 'P_IDQTDEZERO'
                        ),
                );
        }
    }
    
    /**
     * @param $strategyName
     * @return Strategy\ReportStrategy
     * @throws Exception
     */
	protected function getStrategyByName($strategyName) {
		foreach ($this->reportStrategies as $reportStrategy) {
			if ($reportStrategy->getName() == $strategyName) {
				return $reportStrategy;
			}
		}
		throw Exception::strategyNotFound($strategyName);
	}
}
